// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.
//please permission first.
//before you used this code:)
//twitter : @DevHSPE
// To use centroid sampling we need to have version 300 es shaders, which requires changing:
// attribute to in
// varying to out when in vertex shaders or in when in fragment shaders
// defining an out vec4 FragColor and replacing uses of gl_FragColor with FragColor
// texture2D to texture

#if __VERSION__ >= 300
#define attribute in
#define varying out

#else
#endif

uniform MAT4 WORLDVIEWPROJ;
uniform float RENDER_DISTANCE;
uniform vec4 FOG_COLOR;
uniform vec4 CURRENT_COLOR;
uniform vec2 FOG_CONTROL;

attribute mediump vec4 POSITION;
attribute vec4 COLOR;

#include "setHSPE/struct.h"

varying vec4 color;

void main(){

vec4 fc = FOG_COLOR;
vec4 cc = CURRENT_COLOR;
vec2 fcc = FOG_CONTROL;
vec4 Xpos = POSITION;
float distpos = clamp(gl_Position.z / RENDER_DISTANCE -.7,.0,.5);

detection at;
at.day = pow(max(min(1.-fc.b*1.2,1.), .0), .5);
at.night = pow(max(min(1.-fc.r *1.5,1.),.0),1.2);
at.rain = (1.-pow(fcc.y, 11.));

vec4 coloring[4] = vec4[4](vec4(1.2), vec4(.2,.2,.2,-5.3),vec4(1.,1.,1.,-5.), vec4(1.,.9,.8,-3.));
vec4 cday = coloring[0];
vec4 cnight = coloring[1];
vec4 crain = coloring[2];
vec4 cdusk = coloring[3];
vec4 colorc = mix(mix(mix(cday, cdusk, at.day), cnight, at.night),crain,at.rain);

Xpos.y -= (.1,.2,clamp(length(POSITION.xyz),0.,1.))*.35-.11;

//Result
vec4 JillValentine = mix(mix(COLOR*cc,fc,distpos+.5),fc,colorc);

//Activator
gl_Position = WORLDVIEWPROJ*Xpos;
color = JillValentine;}