// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.
/*
please permission first.
before you used this code:)
twitter : @DevHSPE
*/
#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300

#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv;
#else
_centroid in vec2 uv;
#endif

#else

varying vec2 uv;

#endif

varying highp vec3 poss;

#include "uniformShaderConstants.h"
#include "util.h"
#include "setHSPE/library.h"
#include "setHSPE/noise.h"
#include "setHSPE/tonemap.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;

uniform highp float TIME;

void main(){
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE)
highp	vec4 diffuse = texture2D( TEXTURE_0, uv );
#else
highp	vec4 diffuse = texture2D_AA(TEXTURE_0, uv );
#endif

#ifdef ALPHA_TEST
	if(diffuse.a < 0.5)
		discard;
#endif

highp vec2 ub = poss.zx;
    ub = vec2((atan(ub.y,ub.x)) - TIME*.1, sqrt(ub.x*ub.x + ub.y*ub.y));
    highp float g = pow(1.-ub.y, 10.)*10.;
    highp vec3 result = vec3(sin((ub.x + pow(ub.y, 0.2)*WHIRL) * ARM_COUNT)) + g - ub.y*2.2;
    diffuse = vec4(result/5.,1.0)*vec4(.6,.0,.6,1.);

gl_FragColor = diffuse;}
