// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.

#include "fragmentVersionSimple.h"
#include "setHSPE/library.h"
#include "setHSPE/struct.h"
#include "setHSPE/noise.h"

varying highp vec3 poss;

uniform vec4 FOG_COLOR;
uniform vec2 FOG_CONTROL;
uniform vec4 CURRENT_COLOR;
uniform highp float TIME;

/*
please permission first.
before you used this code:)
twitter : @DevHSPE
*/

void main(){
highp float warpAmplitude = 10.;
highp float warpFrequency = .04;

vec4 fc = FOG_COLOR;
vec2 fcc = FOG_CONTROL;
vec4 cc = CURRENT_COLOR;

detection at;
at.rain = (1.-pow(fcc.y, 11.));
at.night = pow(max(min(1.-fc.r *1.5,1.),.0),1.2);
at.dusk = pow(max(min(1.-fc.b*1.2,1.), .0), .5);
float lp = length(poss.xz);

vec4 coloring[4] = vec4[4](vec4(0.,.2,1.3,1.), vec4(.1,.12,.3,0.), vec4(.7,.7,.73,.0)*fc,  vec4(0.1,0.,2.,1.));
vec4 cday = coloring[0];
vec4 cnight = coloring[1];
vec4 crain = coloring[2];
vec4 cdusk = coloring[3];
vec4 color = mix(mix(mix(cday, cdusk,at.dusk), cnight, at.night),crain,at.rain);

vec4 G1 = mix(mix(mix(fc,fc,at.dusk),fc,at.night),fc,at.rain);
vec4 G2 = mix(mix(mix(fc,fc,at.dusk),fc,at.night),fc,at.rain);
vec4 G3 = mix(mix(mix(fc,vec4(1.,.9,.7,1.),at.dusk),vec4(.1,.15,.25,1.),at.night),fc,at.rain);
vec4 G4 = mix(mix(mix(fc,vec4(.9,.8,.5,1.),at.dusk),vec4(.07,.1,.2,1.),at.night),fc,at.rain);
vec4 G5 = mix(mix(mix(fc,vec4(.9,.7,.8,1.),at.dusk),vec4(.04,.08,.15,1.),at.rain),fc,at.rain);
vec4 G6 = mix(mix(mix(color,vec4(.8,.6,.7,1.),at.dusk),vec4(.015,.025,.1,1.),at.night),fc,at.rain);
vec4 G7 = mix(mix(mix(color,vec4(.6,.5,.8,1.),at.dusk),vec4(.07,.1,.2,1.),at.night),fc,at.rain);
vec4 G8 = mix(mix(mix(color,vec4(.4,.3,.7,1.),at.dusk),vec4(.04,.08,.15,1.),at.night),fc,at.rain);
vec4 G9 = mix(mix(mix(color,vec4(.3,.2,.6,1.),at.dusk),vec4(.015,.025,.1,1.),at.night),fc,at.rain);
vec4 G10 = mix(mix(mix(color,vec4(.0,0.,.5,1.),at.dusk),vec4(.015,.025,.1,1.),at.night),fc,at.rain);
vec4 sky = mix(color,G10,pow(clamp(lp*1.5,.0,1.),2.));

sky = mix(sky, G9, pow(clampA(lp*1.47),2.2));
sky = mix(sky, G8, pow(clampA(lp*1.43),2.1));
sky = mix(sky, G7, pow(clampA(lp*1.39),2.2));
sky = mix(sky, G6, pow(clampA(lp*1.35),2.1));
sky = mix(sky, G5, pow(clampA(lp*1.32),2.2));
sky = mix(sky, G4, pow(clampA(lp*1.3),2.3));
sky = mix(sky, G3, pow(clampA(lp*1.2),3.2));
sky = mix(sky, G2, pow(clampA(lp*1.1),2.));
sky = mix(sky, G1, pow(clampA(lp*1.),2.));

vec4 result = mix(sky, fc, cc);
gl_FragColor = vec4(result);}