// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.
//please permission first.
//before you used this code:)
//twitter : @DevHSPE
#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300

#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
_centroid in highp vec2 uv;
#else
_centroid in vec2 uv;
#endif

#else

varying vec2 uv;

#endif

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"
#include "uniformRenderChunkConstants.h"
#include "util.h"
#include "setHSPE/library.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;

void main(){
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE)
	vec4 HSdiff = texture2D( TEXTURE_0, uv );
#else
	vec4 HSdiff = texture2D_AA(TEXTURE_0, uv );
#endif

vec2 fcc = FOG_CONTROL;
vec4 fc = FOG_COLOR;
vec4 sfc = max(fc, vec4(1.0));
float rain =  (1.-pow(fcc.y, 11.));
float night = pow(max(min(1.-fc.r *1.5,1.),.0),1.2);
float morn = pow(max(min(1.-fc.b*1.2,1.), 0.),.5);
float Fade = 1.*(.7-rain);
float Gedhe = 1.*pow(2., night);
HSdiff.rgb *= Gedhe;
HSdiff.rgb *= mix(vec3(1.),vec3(2.5),morn);
HSdiff.a *= Fade;
gl_FragColor = HSdiff;}
