// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.    
//please permission first.
//before you used this code:)
//twitter : @DevHSPE
#include "fragmentVersionCentroid.h"

#if __VERSION__ >= 300
	#ifndef BYPASS_PIXEL_SHADER
		#if defined(TEXEL_AA) && defined(TEXEL_AA_FEATURE)
			_centroid in highp vec2 uv0;
			_centroid in highp vec2 uv1;
		#else
			_centroid in vec2 uv0;
			_centroid in vec2 uv1;
		#endif
	#endif
#else
	#ifndef BYPASS_PIXEL_SHADER
		varying vec2 uv0;
		varying vec2 uv1;
	#endif
#endif

varying vec4 color;
varying highp vec3 wpos;
varying highp vec3 poss;
varying highp vec3 look;
varying highp vec3 screen;

uniform vec2 FOG_CONTROL;
uniform vec4 FOG_COLOR;
uniform float RENDER_DISTANCE;
uniform float FAR_CHUNKS_DISTANCE;
uniform highp float TIME;

#ifdef FOG
varying vec4 fogColor;
#endif

#include "uniformShaderConstants.h"
#include "util.h"

#include "setHSPE/struct.h"
#include "setHSPE/mapping.h"
#include "setHSPE/experimental.h"

LAYOUT_BINDING(0) uniform sampler2D TEXTURE_0;
LAYOUT_BINDING(1) uniform sampler2D TEXTURE_1;
LAYOUT_BINDING(2) uniform sampler2D TEXTURE_2;

void main(){
#ifdef BYPASS_PIXEL_SHADER
	gl_FragColor = float4(0, 0, 0, 0);
	return;
#else 

#if USE_TEXEL_AA
	float4 HSdiff = texture2D_AA(TEXTURE_0, uv0);
#else
	float4 HSdiff = texture2D(TEXTURE_0, uv0);
#endif

#ifdef SEASONS_FAR
	HSdiff.a = 1.0;
#endif

#if USE_ALPHA_TEST
	#ifdef ALPHA_TO_COVERAGE
	#define ALPHA_THRESHOLD 0.05
	#else
	#define ALPHA_THRESHOLD 0.5
	#endif
	if(HSdiff.a < ALPHA_THRESHOLD){
		discard; 
      return;}
#endif

float4 inColor = color;
float2 fcc = FOG_CONTROL;
float3 fv = sqrt(1.3*inColor.rgb);
float4 fc = FOG_COLOR;

float shy = uv1.y;
float shx = uv1.x;
float timeset = texture2D(TEXTURE_1, float2(.0, 1.)).r;

timeset = clampA((timeset-.5) * 2.);
PS_input PSinput; 
detection at;
at.day = timeset;
at.night = 1.-timeset;
at.dusk = .5-abs(.5-timeset);
at.rain = (1.-pow(fcc.y, 11.));
at.cave = 1.-shy;
at.sunset = pow(max(min(1.-fc.b*1.2,1.), 0.),.5);
at.midnight = pow(max(min(1.-fc.r*1.5,1.),.0),1.2);
at.morning = clampA((1. - fc.b)*1.5)*clampA((fc.r -.15)*1.25);

at.day *= shy;
at.night *= shy;
at.dusk *= shy;
at.rain *= shy;
at.sunset *= shy;
at.midnight *= shy;
at.morning *= shy;

#if defined(BLEND)
	HSdiff.a *= inColor.a;
#endif

PSinput.wnz = uvector(uv0);
PSinput.tex = texture2D(TEXTURE_0,uv0);

#if !defined(ALWAYS_LIT)
	HSdiff *= texture2D( TEXTURE_1, uv1 );
#endif

#ifndef SEASONS
	#if !USE_ALPHA_TEST && !defined(BLEND)
		HSdiff.a = inColor.a;
	#endif
    HSdiff.rgb *= mix(inColor.rgb,fv,at.cave);
   #else
	float2 uv = inColor.xy;
	HSdiff.rgb *= mix(float3(1.0,1.0,1.0), texture2D( TEXTURE_2, uv).rgb*2.0, inColor.b);
	HSdiff.rgb *= inColor.aaa;
	HSdiff.a = 1.;
#endif

highp float3 dir[3];
dir[0] = normalize(cross(ddx(wpos),ddy(wpos)));
dir[1] = normalize(cross(ddx(poss), ddy(poss)));
dir[2] = normalize(cross(ddx(poss.zyx), ddy(poss.zyx)));

other clr;
clr.Shadows = float3(.925)+shx*float3(.12);
clr.Shadows= mix(clr.Shadows, float3(1.), at.night);
clr.Shadows= mix(clr.Shadows, float3(1.), at.rain);
clr.Shadows= mix(clr.Shadows, float3(.95), at.dusk);
clr.Leaves = float3(1.1,1.2,1.1);
clr.Exposure = float3(1.2);
clr.underWater = float3(1.,1.,1.5);
clr.SeaLantern = float3(.0, 2.8, 3.);
clr.Grass = float3(.8);
clr.Dirlight[0] = mix(float3(1.),float3(1.2),maxA(dir[1].z));
clr.Dirlight[1] = mix(float3(1.),float3(1.2),maxA(dir[2].x));
clr.Dirlight[2] = mix(float3(1.),float3(1.5,1.5,0.),maxA(dir[1].z));
clr.Dirlight[3] = mix(float3(1.),float3(2.,2.,0.),maxA(dir[2].x));
clr.Grayscale = float3[2](HSS(HSdiff.rgb,.6),HSS(HSdiff.rgb,.8));
clr.Distpos = inColor.a * (length(wpos) /   RENDER_DISTANCE * +.7);

float shside;
float ref_b;
float3 Torch;
float3 ref_t;
float3 GSnight;
float3 GSrain;
float3 Godrays;
float4 wet;

   shside  = color.g+.7*(color.g-color.b);
    Torch =  light(HSdiff.rgb, clr, shx, at);
     ref_b = refleks(wpos, dir[0], at);
      ref_t = refleksi(poss, shx);
GSnight = clr.Grayscale[1];
  GSrain = clr.Grayscale[0];
Godrays = sunbeam(HSdiff.rgb,screen,wpos,poss,at);
        wet = texture2D(TEXTURE_0,HSdiff.xz);
            
HSdiff.rgb = HSTM(HSdiff.rgb);
HSdiff.rgb = HSS(HSdiff.rgb, 1.6);
HSdiff.rgb = mix(HSdiff.rgb,GSnight,at.night);
HSdiff.rgb *= clrWorld(HSdiff.rgb, at);
HSdiff.rgb *= mix(float3(1.), GSrain, at.rain);
HSdiff.rgb *= clr.Dirlight[1];
HSdiff.rgb *= mix(float3(1.), clr.Exposure, at.sunset);
HSdiff.rgb *= mix(float3(1.),float3(1.4), at.rain);
_metallic(HSdiff.rgb, PSinput.wnz, ref_b,at);
_ores(HSdiff.rgb,PSinput, shx,at);

if(!(fcc.x <.55)){
HSdiff.rgb *= mix(float3(1.),clr.Dirlight[2],at.dusk);
if(!(color.g>color.r&&color.a>0.)){
HSdiff.rgb *= clr.Dirlight[0];
HSdiff.rgb *= mix(float3(1.),clr.Dirlight[3],at.dusk);}}

#ifdef BLEND
Godrays *= 4.;
if(!(color.b > color.r)){
HSdiff.rgb += ref_b;
HSdiff.rgb += ref_t;}
#endif

HSdiff.rgb += Godrays*15.;
if(!isWater(color) && !isUnderwater(fcc, fc)){
HSdiff += wet*.2*at.rain*(1.-at.night);
HSdiff.rgb += puddle(poss,dir[1], at)*3.*HSdiff.rgb;
HSdiff.rgb += wet_wave(poss)*.45*max(0.,dir[1].y)*at.rain*(1.-at.cave)*(1.-at.night)*HSdiff.rgb;}

if(isNether(fc)){
HSdiff.rgb *= float3(1.2);
float FogNthr = clamp(length(wpos)/RENDER_DISTANCE* 1.,.3,2.);
float3 FogNthrON = mix(HSdiff.rgb, fc.rgb*float3(1.6,.5,.1),FogNthr);
HSdiff.rgb = FogNthrON;}

if(isTheEnd(fc)){
Torch *= 0.;
float3 TorchEnd = float3(.2,.0,.7)*pow(shx*1.5,2.);
HSdiff.rgb += TorchEnd;}

if(color.a == 0.){
HSdiff.rgb *= clr.Leaves;
shside = color.g*1.2;
clr.Shadows = float3(.89)+shx*float3(.16);}
HSdiff.rgb = shadow(HSdiff.rgb, clr, shside, shy);
if(color.g > color.r){HSdiff.rgb *= clr.Grass;}

#ifndef SEASONS
if(isWater(color)){
HSdiff.a -=.15;
HSdiff.rgb = clrWater(HSdiff.rgb, at);
HSdiff.a += clr.Distpos;}

if(!isUnderwater(fcc,fc)){
HSdiff.rgb += Torch;}else{
HSdiff.rgb += clr.SeaLantern*pow(shx*.35,1.5);
HSdiff.rgb *= clr.underWater;}
#endif

#ifdef LOW_PRECISION
FOGGY fog;
fog.Atmosphere = length(-wpos.xz *2.) / FAR_CHUNKS_DISTANCE*.2;
fog.Atmosphere = clamp(fog.Atmosphere, .1, 2.8);
HSdiff.rgb = mix(HSdiff.rgb, fc.rgb*float3(1.,1.1,1.1), fog.Atmosphere);

fog.foggyRain = clampA(length(-wpos.stp*3.) / RENDER_DISTANCE *1.5);
fog.foggyRainON = mix(HSdiff.rgb, fc.rgb, fog.foggyRain);
HSdiff.rgb = mix(HSdiff.rgb, fog.foggyRainON, at.rain);

fog.foggyDusk = clamp(length(1.-wpos.z) / RENDER_DISTANCE *1.4, .15, 1.);
fog.foggyDuskON = mix(HSdiff.rgb, fc.rgb, fog.foggyDusk);
HSdiff.rgb = mix(HSdiff.rgb, fog.foggyDuskON, at.sunset);

fog.foggyNight = clamp(length(wpos) / FAR_CHUNKS_DISTANCE * .1, .4, 1.5);
fog.foggyNightON = mix(HSdiff.rgb, fc.rgb, fog.foggyNight);
HSdiff.rgb = mix(HSdiff.rgb, fog.foggyNightON, at.midnight);

FOG ground;
ground.fogDusk = clamp(length(wpos.y)/FAR_CHUNKS_DISTANCE*4.,.2,2.)*(1.-at.night);
ground.fogDuskON = mix(HSdiff.rgb, fc.rgb, ground.fogDusk);
HSdiff.rgb = mix(HSdiff.rgb, ground.fogDuskON, at.sunset);
#endif

#ifdef FOG
HSdiff.rgb = mix( HSdiff.rgb, fogColor.rgb, fogColor.a);
#endif

gl_FragColor = HSdiff;

#endif // BYPASS_PIXEL_SHADER
}