// __multiversion__
// This signals the loading code to prepend either #version 100 or #version 300 es as apropriate.                  
//please permission first.
//before you used this code:)
//twitter : @DevHSPE
#include "vertexVersionCentroid.h"
#if __VERSION__ >= 300
	#ifndef BYPASS_PIXEL_SHADER
		_centroid out vec2 uv0;
		_centroid out vec2 uv1;
	#endif
#else
	#ifndef BYPASS_PIXEL_SHADER
		varying vec2 uv0;
		varying vec2 uv1;
	#endif
#endif

#ifndef BYPASS_PIXEL_SHADER
	varying vec4 color;
#endif

varying highp vec3 wpos;
varying highp vec3 poss;
varying highp vec3 look;
varying highp vec3 screen;

#ifdef FOG
	varying vec4 fogColor;
#endif

#include "uniformWorldConstants.h"
#include "uniformPerFrameConstants.h"
#include "uniformShaderConstants.h"
#include "uniformRenderChunkConstants.h"
#include "setHSPE/library.h"
#include "setHSPE/detection.h"

attribute POS4 POSITION;
attribute vec4 COLOR;
attribute vec2 TEXCOORD_0;
attribute vec2 TEXCOORD_1;

const float rA = 1.0;
const float rB = 1.0;
const vec3 UNIT_Y = vec3(0,1,0);
const float DIST_DESATURATION = 56.0 / 255.0; //WARNING this value is also hardcoded in the water color, don'tchange

#define HSPERV

void main(){
    POS4 worldPos;
#ifdef AS_ENTITY_RENDERER
		POS4 pos = WORLDVIEWPROJ * POSITION;
		worldPos = pos;
#else
    worldPos.xyz = (POSITION.xyz * CHUNK_ORIGIN_AND_SCALE.w) + CHUNK_ORIGIN_AND_SCALE.xyz;
    worldPos.w = 1.0;
    // Transform to view space before projection instead of all at once to avoid floating point errors
    // Not required for entities because they are already offset by camera translation before rendering
    // World position here is calculated above and can get huge
    POS4 pos = WORLDVIEW * worldPos;
    pos = PROJ * pos;
#endif
    gl_Position = pos;
#ifndef BYPASS_PIXEL_SHADER
 uv0 = TEXCOORD_0;
  uv1 = TEXCOORD_1;
	color = COLOR;
   uv1.x = max((uv1.x - .32) * 1.5, .0);
   wpos = worldPos.xyz;
   poss = POSITION.xyz;
  look = VIEW_POS;
 screen.xy = pos.xy / (pos.z + 1.0);
#endif

///// find distance from the camera
#ifdef HSPERV
#if defined(FOG) || defined(BLEND)
	#ifdef FANCY
		vec3 relPos = -worldPos.xyz;
		float cameraDepth = length(relPos);
	#else
		float cameraDepth = pos.z;
	#endif
#endif

POS3 p = POSITION.xyz+VIEW_POS;
POS3 q = worldPos.xyz;

highp float rain = (1.-pow(FOG_CONTROL.y, 11.)) * uv1.y;
highp float pq = sin(TIME*2.3+q.x+cos(TIME*1.4+q.x+q.y+q.z));
highp float obh = .09*sin(2.0 * (TIME + poss.x  + poss.z))+ .05 * sin(2.* (TIME*1.2 + poss.x )); highp float obh_b = .09*sin(2.0 * (TIME + poss.x  + poss.x + poss.z + poss.y + poss.x))+ .05 * sin(2.* (TIME*1.2 + poss.z ));

#ifdef ALPHA_TEST
if(color.g>color.r&&color.a>0. || color.r > color.g  && color.g > color.b && color.a != 0.){
gl_Position.x += sin(TIME*1.5+p.z+p.z+p.z+cos(TIME*.5+q.y+q.x))*sin(q.x+q.y)*.052;}

if(color.a == 0.){
gl_Position.x += sin(TIME * 3. + p.x + p.z + p.x + p.z + p.y) * sin(p.z) * .04;}

if(color.g + color.g > color.r + color.b){
gl_Position.x += sin(TIME * 5.5 + q.x + q.y + q.z) * .04 * rain;}
#endif

#ifndef SEASONS
if(isWater(color)){
gl_Position.y += pq*.085 ;}
 if(color.b > color.r && color.b > color.g){
gl_Position.y += pq*.02 ;}
if(color.b > color.r &&  color.b > color.g){
gl_Position.y += pq*.01 ;}

if(isUnderwater(FOG_CONTROL, FOG_COLOR) && color.a != 0.){
color.rgb += obh-obh_b+obh*obh_b*vec3(.1);
gl_Position.xy += sin(TIME * 2.8 + q.x + q.z + q.y + q.z ) * .035;}
#endif

///// apply fog

#ifdef FOG
	float len = cameraDepth / RENDER_DISTANCE;
	#ifdef ALLOW_FADE
		len += RENDER_CHUNK_FOG_ALPHA;
	#endif

    fogColor.rgb = FOG_COLOR.rgb;
	fogColor.a = clamp((len - FOG_CONTROL.x) / (FOG_CONTROL.y - FOG_CONTROL.x), 0.0, 1.0);
#endif

///// blended layer (mostly water) magic
#ifdef BLEND
	//Mega hack: only things that become opaque are allowed to have vertex-driven transparency in the Blended layer...
	//to fix this we'd need to find more space for a flag in the vertex format. color.a is the only unused part
	bool shouldBecomeOpaqueInTheDistance = color.a < 0.95;
	if(shouldBecomeOpaqueInTheDistance) {
		#ifdef FANCY  /////enhance water
			float cameraDist = cameraDepth / FAR_CHUNKS_DISTANCE;
			color = COLOR;
		#else
			// Completely insane, but if I don't have these two lines in here, the water doesn't render on a Nexus 6
			vec4 surfColor = vec4(color.rgb, 1.0);
			color = surfColor;
			vec3 relPos = -worldPos.xyz;
			float camDist = length(relPos);
			float cameraDist = camDist / FAR_CHUNKS_DISTANCE;
		#endif //FANCY
		float alphaFadeOut = clamp(cameraDist, 0.0, 1.0);
		color.a = mix(color.a, 1.0, alphaFadeOut);}
#endif

#ifndef BYPASS_PIXEL_SHADER
	#ifndef FOG
		// If the FOG_COLOR isn't used, the reflection on NVN fails to compute the correct size of the constant buffer as the uniform will also be gone from the reflection data
		color.rgb += FOG_COLOR.rgb * 0.000001;
	   #endif
  #endif
#endif
}
