#include "ShaderConstants.fxh"
#include "util.fxh"

/*
Please permission first. if you used this code:)
Twitter: @DevHSPE
Facebook: Wanzekk
Youtube: Wanze'
*/

struct PS_Input
{
    float4 position : SV_Position;
    float3 poss : POSS;
    float2 uv : TEXCOORD_0_FB_MSAA;
};

struct PS_Output
{
    float4 color : SV_Target;
};

#define ARM_COUNT 5.
#define WHIRL 14.0

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{
#if !defined(TEXEL_AA) || !defined(TEXEL_AA_FEATURE) || (VERSION < 0xa000 /*D3D_FEATURE_LEVEL_10_0*/) 
	float4 diffuse = TEXTURE_0.Sample(TextureSampler0, PSInput.uv);
#else
	float4 diffuse = texture2D_AA(TEXTURE_0, TextureSampler0, PSInput.uv);
#endif

#ifdef ALPHA_TEST
    if( diffuse.a < 0.5 )
    {
        discard;
    }
#endif

float2 ub = PSInput.poss.zx;
    ub = float2((atan2(ub.y, ub.x)) - TIME*.1, sqrt(ub.x*ub.x + ub.y*ub.y));
    float g = pow(1.-ub.y, 10.)*10.;
float mylove = sin((ub.x + pow(ub.y, 0.2)*WHIRL) * ARM_COUNT);
float3 result = float3(mylove, mylove, mylove) + g - ub.y*2.2;
    diffuse = float4(result/5.,1.)*float4(.6,.0,.6,1.)*4.8;

#ifdef IGNORE_CURRENTCOLOR
    PSOutput.color = diffuse;
#else
    PSOutput.color = CURRENT_COLOR * diffuse;
#endif

#ifdef WINDOWSMR_MAGICALPHA
    // Set the magic MR value alpha value so that this content pops over layers
    PSOutput.color.a = 133.0f / 255.0f;
#endif
}
