#include "ShaderConstants.fxh"
#include "setHSPE/struct.fxh"

/*
Please permission first. if you used this code:)
Twitter: @DevHSPE
Facebook: Wanzekk
Youtube: Wanze'
*/

struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
    float3 poss : POSS;
};

struct PS_Output
{
    float4 color : SV_Target;
};

ROOT_SIGNATURE
void main(in PS_Input PSInput, out PS_Output PSOutput)
{

float4 fc = FOG_COLOR;
float2 fcc = FOG_CONTROL;
float4 cc = CURRENT_COLOR;

detection at;
at.rain = (1.-pow(fcc.y, 11.));
at.night = pow(max(min(1.-fc.r *1.5,1.),.0),1.2);
at.dusk = pow(max(min(1.-fc.b*1.2,1.), .0), .5);
float lp = length(PSInput.poss.xz);

float4 cday = float4(0.,.2,1.3,1.);
float4 cnight = float4(.1,.12,.3,0.);
float4 crain = float4(.7,.7,.73,.0)*fc;
float4 cdusk = float4(0.1,0.,2.,1.);
float4 colorsky = lerp(lerp(lerp(cday, cdusk,at.dusk), cnight, at.night),crain,at.rain);

float4 G1 = lerp(lerp(lerp(fc,fc,at.dusk),fc,at.night),fc,at.rain);
float4 G2 = lerp(lerp(lerp(fc,fc,at.dusk),fc,at.night),fc,at.rain);
float4 G3 = lerp(lerp(lerp(fc,float4(1.,.9,.7,1.),at.dusk),float4(.1,.15,.25,1.),at.night),fc,at.rain);
float4 G4 = lerp(lerp(lerp(fc,float4(.9,.8,.5,1.),at.dusk),float4(.07,.1,.2,1.),at.night),fc,at.rain);
float4 G5 = lerp(lerp(lerp(fc,float4(.9,.7,.8,1.),at.dusk),float4(.04,.08,.15,1.),at.rain),fc,at.rain);
float4 G6 = lerp(lerp(lerp(colorsky,float4(.8,.6,.7,1.),at.dusk),float4(.015,.025,.1,1.),at.night),fc,at.rain);
float4 G7 = lerp(lerp(lerp(colorsky,float4(.6,.5,.8,1.),at.dusk),float4(.07,.1,.2,1.),at.night),fc,at.rain);
float4 G8 = lerp(lerp(lerp(colorsky,float4(.4,.3,.7,1.),at.dusk),float4(.04,.08,.15,1.),at.night),fc,at.rain);
float4 G9 = lerp(lerp(lerp(colorsky,float4(.3,.2,.6,1.),at.dusk),float4(.015,.025,.1,1.),at.night),fc,at.rain);
float4 G10 = lerp(lerp(lerp(colorsky,float4(.0,0.,.5,1.),at.dusk),float4(.015,.025,.1,1.),at.night),fc,at.rain);
float4 sky = lerp(colorsky,G10,pow(clamp(lp*1.5,.0,1.),2.));

sky = lerp(sky, G9, pow(clamp(lp*1.47,0.,1.),2.2));
sky = lerp(sky, G8, pow(clamp(lp*1.43,0.,1.),2.1));
sky = lerp(sky, G7, pow(clamp(lp*1.39,0.,1.),2.2));
sky = lerp(sky, G6, pow(clamp(lp*1.35,0.,1.),2.1));
sky = lerp(sky, G5, pow(clamp(lp*1.32,0.,1.),2.2));
sky = lerp(sky, G4, pow(clamp(lp*1.3,0.,1.),2.3));
sky = lerp(sky, G3, pow(clamp(lp*1.2,0.,1.),3.2));
sky = lerp(sky, G2, pow(clamp(lp*1.1,0.,1.),2.));
sky = lerp(sky, G1, pow(clamp(lp*1.,0.,1.),2.));

float4 result = lerp(sky, fc, cc);

    PSOutput.color = float4(result);
}